package com.jwkj.qsydw.controller;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.jwkj.qsydw.services.HttpClientService;
import com.jwkj.qsydw.vo.Npvo;
import com.jwkj.qsydw.vo.PointPosition;
import com.jwkj.qsydw.vo.ReadResults;
import com.jwkj.qsydw.vo.StatusVo;
import com.jwkj.qsydw.vo.wrapper.Wrapper;
import jakarta.annotation.Resource;
import org.nlsd.common.BaseResponse;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Xu·LinPeng
 */
@RestController
@RequestMapping("/transform")
public class Fxjjc {

    @Resource
    HttpClientService httpClientService;
    @Resource
    PointPosition pointPosition;

    @PostMapping("/fxjjc")
    public BaseResponse<JSONObject> data(){


        String var = pointPosition.getPointPosition("qsyfxjjc");
        String res = httpClientService.httpService(var);
        Wrapper wrapper = JSON.parseObject(res, Wrapper.class);
        List<ReadResults> readResultsList = wrapper.getReadResults();
//        TestData testData = new TestData();
//        List<ReadResults> readResultsList = testData.getListData();
        List<Npvo<String>> list = new ArrayList<>();
        list.add(new Npvo<>("提升高度",readResultsList.get(0).getV()+"m"));
        list.add(new Npvo<>("提升速度",readResultsList.get(1).getV()+"m/s"));
        list.add(new Npvo<>("制动油压",readResultsList.get(2).getV()+"Mpa"));
        list.add(new Npvo<>("电枢电流",readResultsList.get(3).getV()+"A"));
        list.add(new Npvo<>("励磁电流",readResultsList.get(4).getV()+"A"));
        list.add(new Npvo<>("润滑油压",readResultsList.get(5).getV()+"Mpa"));
        list.add(new Npvo<>("电机温度1",readResultsList.get(6).getV()+"℃"));
        list.add(new Npvo<>("电机温度2",readResultsList.get(7).getV()+"℃"));
        List<Npvo<List<Npvo<List<StatusVo>>>>> itemList = new ArrayList<>();
        List<Npvo<List<StatusVo>>> paramsList = new ArrayList<>();
        List<StatusVo> params = new ArrayList<>();
        params.add(new StatusVo(readResultsList.get(8).getV()));
        params.add(new StatusVo(readResultsList.get(9).getV()));
        paramsList.add(new Npvo<>("过卷",params));
        itemList.add(new Npvo<>("状态",paramsList));
        JSONObject result = new JSONObject();
        result.put("list",list);
        result.put("itemList",itemList);
        return new BaseResponse<>(200,"OK",result,"请求成功");
    }

}
