package com.jwkj.qsydw.controller;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.jwkj.qsydw.services.HttpClientService;
import com.jwkj.qsydw.vo.Npvo;
import com.jwkj.qsydw.vo.PointPosition;
import com.jwkj.qsydw.vo.ReadResults;
import com.jwkj.qsydw.vo.wrapper.Wrapper;
import jakarta.annotation.Resource;
import org.nlsd.common.BaseResponse;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Xu·LinPeng
 */
@RestController
@RequestMapping("/transform")
public class Sbf786 {

    @Resource
    HttpClientService httpClientService;
    @Resource
    PointPosition pointPosition;

    @PostMapping("/qsy786sbf")
    public BaseResponse<JSONObject> data(){


        String var = pointPosition.getPointPosition("qsy786sbf");
        String res = httpClientService.httpService(var);
        Wrapper wrapper = JSON.parseObject(res, Wrapper.class);
        List<ReadResults> readResultsList = wrapper.getReadResults();
//        TestData testData = new TestData();
//        List<ReadResults> readResultsList = testData.getListData();
        List<Npvo<String>> list = new ArrayList<>();
        list.add(new Npvo<>("1#管路流量",readResultsList.get(0).getV()+"m³/h"));
        list.add(new Npvo<>("2#管路流量",readResultsList.get(1).getV()+"m³/h"));
        list.add(new Npvo<>("3#管路流量",readResultsList.get(2).getV()+"m³/h"));
        list.add(new Npvo<>("1#水位",readResultsList.get(3).getV()+"m"));
        list.add(new Npvo<>("2#水位",readResultsList.get(4).getV()+"m"));
        List<Npvo<List<Npvo<List<String>>>>> itemList = new ArrayList<>();
        List<Npvo<List<String>>> paramsList = new ArrayList<>();
        List<String> var3 = new ArrayList<>();
        var3.add(readResultsList.get(5).getV()+"Mpa");
        paramsList.add(new Npvo<>("负压",var3));
        List<String> var3_1 = new ArrayList<>();
        var3_1.add(readResultsList.get(6).getV()+"Mpa");
        paramsList.add(new Npvo<>("正压",var3_1));
        itemList.add(new Npvo<>("一号泵控制",paramsList));
        List<Npvo<List<String>>> paramsList2 = new ArrayList<>();
        List<String> var4_1 = new ArrayList<>();
        var4_1.add(readResultsList.get(7).getV()+"Mpa");
        paramsList2.add(new Npvo<>("负压",var4_1));
        List<String> var4_2 = new ArrayList<>();
        var4_2.add(readResultsList.get(8).getV()+"Mpa");
        paramsList2.add(new Npvo<>("正压",var4_2));
        itemList.add(new Npvo<>("二号泵控制",paramsList2));
        List<Npvo<List<String>>> paramsList3 = new ArrayList<>();
        List<String> var5_1 = new ArrayList<>();
        var5_1.add(readResultsList.get(9).getV()+"Mpa");
        paramsList3.add(new Npvo<>("负压",var5_1));
        List<String> var5_2 = new ArrayList<>();
        var5_2.add(readResultsList.get(10).getV()+"Mpa");
        paramsList3.add(new Npvo<>("正压",var5_2));
        itemList.add(new Npvo<>("三号泵控制",paramsList3));
        JSONObject result = new JSONObject();
        result.put("list",list);
        result.put("itemList",itemList);
        return new BaseResponse<>(200,"OK",result,"请求成功");

    }

}
