package com.jwkj.qsydw.vo;

import java.util.List;

/**
 *
 * 业务接口可以升级为post接口，参数类型为当前类，请求体的内容为
 * {
 *   "pointPositions":[
 *     "111",
 *     "222",
 *     "333"
 *   ],
 *   "pointPosition":"666"
 * }
 *
 * 使用此接口类型可以传点位的代码（PointPosition.class中维护的），
 * 也可以传一个点位数组（需要升级控制层）
 *
 * @author Xu·LinPeng
 */
public class Params {
    public String pointPosition;
    public List<String> pointPositions;

    public Params() {

    }

    public Params(String pointPosition) {

        this.pointPosition = pointPosition;
    }

    public Params(List<String> pointPositions) {

        this.pointPositions = pointPositions;
    }

    public Params(String pointPosition, List<String> pointPositions) {

        this.pointPosition = pointPosition;
        this.pointPositions = pointPositions;
    }

    public String getPointPosition() {

        return pointPosition;
    }

    public void setPointPosition(String pointPosition) {

        this.pointPosition = pointPosition;
    }

    public String getPointPositions() {

        if (pointPositions == null) {
            return null;
        }
        String var = "[";
        for (String p : pointPositions) {
            var += "\"" + p + "\",";
        }
        var = var.substring(0, var.length() - 1);

        var += "]";

        return var;
    }

    public void setPointPositions(List<String> pointPositions) {

        this.pointPositions = pointPositions;
    }

}
